import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class WaveEq extends Frame
{  public double Pi=3.1415926535897932385;
   public int ID1, ID2;public double ER;
   public double LeftP, TopP, sX, sY;
   public double currentX, currentY; // ݂̕`ʒu
   public WaveEq()
   {  setSize(800,700);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private double[][] InitialZ(int N)
   { double [][]Z=new double[2][N+1]; double PN= Pi/N;
     for(int i=0; i <= N; i++) Z[0][i] = Z[1][i] = Math.sin(PN * i);
     return Z;
   }
   private double[][] InitialV(int N)
   { double [][]V=new double[2][N+1];
     for(int i=0; i <= N; i++) V[0][i] = V[1][i] = 0;
     return V;
   }
   private double[][] InitialS(double[][]Z, int N, int M)
   { double [][]R = new double[M+1][N+1];
     for(int k = 1; k <= M; k++) for(int i=0; i <= N; i++) R[k][i] = 0;
     for(int i=0; i <= N; i++) R[0][i] = Z[0][i];
     return R;
   }
   private double[] InitialT(int M)
   { double []R = new double[M+1]; R[0] = 0;
     return R;
   }
  private int Comp(double[][] V,double[][] Z, double[] T, double[][] S,
                   int NumLoop, int N, int SaveN, int M,double DT, double DX, double Alfa)
  {  double Beta = Alfa * Alfa / (DX * DX);
     ID1 = 0; ID2 = 1; int KK = 0;
     for(int k = 1; k<= NumLoop; k++)
     {  for(int j = 1; j< N; j++)
        {  Z[ID2][j] = Z[ID1][j] + DT * V[ID1][j];
           double Acc = Beta * (Z[ID1][j + 1] - 2 * Z[ID1][j] + Z[ID1][j - 1]);
           V[ID2][j] = V[ID1][j] + DT * Acc;
        }
        // E
        V[ID2][0] = 0; V[ID2][100] = 0;
        Z[ID2][0] = 0; Z[ID2][100] = 0;
        // ʂ̕ۑ
        if ((k % SaveN) == 0)
        {  KK = KK + 1;
           T[KK]= (double)(KK * SaveN) * DT;
           for(int j = 0; j<= N; j++) S[KK][j] = Z[ID2][j];
        }
        int Temp = ID2; ID1 = ID2; ID2 = Temp;
     }
     return KK;
   }
   public void drawInit(double X1, double Y1, double SX, double SY)
   {  LeftP = X1; TopP = Y1; sX = SX; sY = SY;
   }
   public int Xpos(double X)
   {  return (int)(LeftP + X * sX);}
   public int Ypos(double Y)
   {  return (int)(TopP  + Y * sY);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   private double MaxValue(double[][][]U, int KX,int KY)
   {  double V = U[0][0][0];int i,j,k;
      for(k = 0; k < 2; k++) for(i = 0; i < KX; i++)
          for(j = 0; j < KY; j++) if(U[k][i][j]>V) V= U[k][i][j];
      return V;
   }
   private double MinValue(double[][][]U, int KX,int KY)
   {  double V = U[0][0][0];int i,j,k;
      for(k = 0; k < 2; k++) for(i = 0; i < KX; i++)
          for(j = 0; j < KY; j++) if(U[k][i][j]<V) V= U[k][i][j];
      return V;
   }
   private void drawResult(Graphics g, double []T, double[][] S, int N, int KK)
   { drawInit( 100, 100, 1, -50);
     g.setColor(new Color(128,128, 128));boolean Flag;int N2 = N/2;
     for(double Y = -1; Y <= 1.2; Y += 0.2) drawLine(g, 0, Y, T[KK], Y );
     for(int i = 0 ; i <= KK ; i += 10) drawLine(g, T[i], -1, T[i], 1.2);
     Flag = false;
     g.setColor(new Color(255,0,0));
     for(int i = 0 ; i <= KK ; i ++)Flag=Draw(g, T[i], S[i][N2],Flag);
     
     drawInit( 100, 400, 5, -200);
     g.setColor(new Color(128,128,128));
      
     for(double Y = -1; Y <= 1.2; Y += 0.2) drawLine(g, 0, Y, N, Y );
     for(int i = 0 ; i <= N ; i += 10) drawLine(g, i, -1, i, 1.2);
   
     g.setColor(new Color(0,0,156));
     for(int i = 0 ; i <= 100 ; i ++)
     { Flag=false;
       for(int j = 0 ; j <= N ; j ++) Flag=Draw(g, j, S[i][j],Flag);
     }   
   
   }
   public void paint(Graphics g)
   { setTitle("1g");
     
     int NLoop=40000; int N = 100; int SaveN = 100; int M = NLoop/ SaveN; 
     double[][] Z = InitialZ(N);
     double[][] V = InitialV(N);
     double[][] S = InitialS(Z, N, M);
     double[]   T = InitialT(M);
     int KK = Comp( V, Z, T, S, NLoop, N, SaveN, M, 0.01, 0.05, 0.05);
     drawResult(g, T, S, N, KK);
   } 
   public static void main(String[] args)
   {  Frame w = new WaveEq();
      w.setVisible(true);
   }
}
